//C++ Abstract Syntax Implementation generated by the BNF Converter.
#include <algorithm>
#include <string>
#include <vector>
#include "Absyn.h"

/********************   PIdent    ********************/
PIdent::PIdent(String p1, Integer p2)
{
	string_ = p1;
	integer_ = p2;
}

PIdent::PIdent(const PIdent & other)
{
	string_ = other.string_;
	integer_ = other.integer_;
	var = other.var;
}

PIdent &PIdent::operator=(const PIdent & other)
{
	PIdent tmp(other);
	swap(tmp);
	return *this;
}

void PIdent::swap(PIdent & other)
{
	std::swap(string_, other.string_);
	std::swap(integer_, other.integer_);
	std::swap(var, other.var);
}

PIdent::~PIdent()
{

}

void PIdent::accept(Visitor *v)
{
	v->visitPIdent(this);
}

PIdent *PIdent::clone() const
{
	return new PIdent(*this);
}



/********************   Prog    ********************/
Prog::Prog(ListTopDef *p1)
{
	listtopdef_ = p1;

}

Prog::Prog(const Prog & other)
{
	listtopdef_ = other.listtopdef_->clone();

}

Prog &Prog::operator=(const Prog & other)
{
	Prog tmp(other);
	swap(tmp);
	return *this;
}

void Prog::swap(Prog & other)
{
	std::swap(listtopdef_, other.listtopdef_);

}

Prog::~Prog()
{
	delete(listtopdef_);

}

void Prog::accept(Visitor *v)
{
	v->visitProg(this);
}

Prog *Prog::clone() const
{
	return new Prog(*this);
}



/********************   FnDef    ********************/
FnDef::FnDef(FunDef *p1)
{
	fundef_ = p1;

}

FnDef::FnDef(const FnDef & other)
{
	fundef_ = other.fundef_->clone();

}

FnDef &FnDef::operator=(const FnDef & other)
{
	FnDef tmp(other);
	swap(tmp);
	return *this;
}

void FnDef::swap(FnDef & other)
{
	std::swap(fundef_, other.fundef_);

}

FnDef::~FnDef()
{
	delete(fundef_);

}

void FnDef::accept(Visitor *v)
{
	v->visitFnDef(this);
}

FnDef *FnDef::clone() const
{
	return new FnDef(*this);
}



/********************   ClDef    ********************/
ClDef::ClDef(ClassDef *p1)
{
	classdef_ = p1;

}

ClDef::ClDef(const ClDef & other)
{
	classdef_ = other.classdef_->clone();

}

ClDef &ClDef::operator=(const ClDef & other)
{
	ClDef tmp(other);
	swap(tmp);
	return *this;
}

void ClDef::swap(ClDef & other)
{
	std::swap(classdef_, other.classdef_);

}

ClDef::~ClDef()
{
	delete(classdef_);

}

void ClDef::accept(Visitor *v)
{
	v->visitClDef(this);
}

ClDef *ClDef::clone() const
{
	return new ClDef(*this);
}



/********************   FuncDef    ********************/
FuncDef::FuncDef(Type *p1, PIdent *p2, ListArg *p3, Block *p4)
{
	type_ = p1;
	pident_ = p2;
	listarg_ = p3;
	block_ = p4;

}

FuncDef::FuncDef(const FuncDef & other)
{
	type_ = other.type_->clone();
	pident_ = other.pident_->clone();
	listarg_ = other.listarg_->clone();
	block_ = other.block_->clone();

}

FuncDef &FuncDef::operator=(const FuncDef & other)
{
	FuncDef tmp(other);
	swap(tmp);
	return *this;
}

void FuncDef::swap(FuncDef & other)
{
	std::swap(type_, other.type_);
	std::swap(pident_, other.pident_);
	std::swap(listarg_, other.listarg_);
	std::swap(block_, other.block_);

}

FuncDef::~FuncDef()
{
	delete(type_);
	delete(pident_);
	delete(listarg_);
	delete(block_);

}

void FuncDef::accept(Visitor *v)
{
	v->visitFuncDef(this);
}

FuncDef *FuncDef::clone() const
{
	return new FuncDef(*this);
}



/********************   Ar    ********************/
Ar::Ar(Type *p1, PIdent *p2)
{
	type_ = p1;
	pident_ = p2;

}

Ar::Ar(const Ar & other)
{
	type_ = other.type_->clone();
	pident_ = other.pident_->clone();

}

Ar &Ar::operator=(const Ar & other)
{
	Ar tmp(other);
	swap(tmp);
	return *this;
}

void Ar::swap(Ar & other)
{
	std::swap(type_, other.type_);
	std::swap(pident_, other.pident_);

}

Ar::~Ar()
{
	delete(type_);
	delete(pident_);

}

void Ar::accept(Visitor *v)
{
	v->visitAr(this);
}

Ar *Ar::clone() const
{
	return new Ar(*this);
}



/********************   ClassDefN    ********************/
ClassDefN::ClassDefN(PIdent *p1, ClassBlock *p2)
{
	pident_ = p1;
	classblock_ = p2;

}

ClassDefN::ClassDefN(const ClassDefN & other)
{
	pident_ = other.pident_->clone();
	classblock_ = other.classblock_->clone();

}

ClassDefN &ClassDefN::operator=(const ClassDefN & other)
{
	ClassDefN tmp(other);
	swap(tmp);
	return *this;
}

void ClassDefN::swap(ClassDefN & other)
{
	std::swap(pident_, other.pident_);
	std::swap(classblock_, other.classblock_);

}

ClassDefN::~ClassDefN()
{
	delete(pident_);
	delete(classblock_);

}

void ClassDefN::accept(Visitor *v)
{
	v->visitClassDefN(this);
}

ClassDefN *ClassDefN::clone() const
{
	return new ClassDefN(*this);
}



/********************   ClassDefE    ********************/
ClassDefE::ClassDefE(PIdent *p1, PIdent *p2, ClassBlock *p3)
{
	pident_1 = p1;
	pident_2 = p2;
	classblock_ = p3;

}

ClassDefE::ClassDefE(const ClassDefE & other)
{
	pident_1 = other.pident_1->clone();
	pident_2 = other.pident_2->clone();
	classblock_ = other.classblock_->clone();

}

ClassDefE &ClassDefE::operator=(const ClassDefE & other)
{
	ClassDefE tmp(other);
	swap(tmp);
	return *this;
}

void ClassDefE::swap(ClassDefE & other)
{
	std::swap(pident_1, other.pident_1);
	std::swap(pident_2, other.pident_2);
	std::swap(classblock_, other.classblock_);

}

ClassDefE::~ClassDefE()
{
	delete(pident_1);
	delete(pident_2);
	delete(classblock_);

}

void ClassDefE::accept(Visitor *v)
{
	v->visitClassDefE(this);
}

ClassDefE *ClassDefE::clone() const
{
	return new ClassDefE(*this);
}



/********************   ClassBl    ********************/
ClassBl::ClassBl(ListClassBlockDef *p1)
{
	listclassblockdef_ = p1;

}

ClassBl::ClassBl(const ClassBl & other)
{
	listclassblockdef_ = other.listclassblockdef_->clone();

}

ClassBl &ClassBl::operator=(const ClassBl & other)
{
	ClassBl tmp(other);
	swap(tmp);
	return *this;
}

void ClassBl::swap(ClassBl & other)
{
	std::swap(listclassblockdef_, other.listclassblockdef_);

}

ClassBl::~ClassBl()
{
	delete(listclassblockdef_);

}

void ClassBl::accept(Visitor *v)
{
	v->visitClassBl(this);
}

ClassBl *ClassBl::clone() const
{
	return new ClassBl(*this);
}



/********************   ClassMthd    ********************/
ClassMthd::ClassMthd(FunDef *p1)
{
	fundef_ = p1;

}

ClassMthd::ClassMthd(const ClassMthd & other)
{
	fundef_ = other.fundef_->clone();

}

ClassMthd &ClassMthd::operator=(const ClassMthd & other)
{
	ClassMthd tmp(other);
	swap(tmp);
	return *this;
}

void ClassMthd::swap(ClassMthd & other)
{
	std::swap(fundef_, other.fundef_);

}

ClassMthd::~ClassMthd()
{
	delete(fundef_);

}

void ClassMthd::accept(Visitor *v)
{
	v->visitClassMthd(this);
}

ClassMthd *ClassMthd::clone() const
{
	return new ClassMthd(*this);
}



/********************   ClassFld    ********************/
ClassFld::ClassFld(Type *p1, ListItem *p2)
{
	type_ = p1;
	listitem_ = p2;

}

ClassFld::ClassFld(const ClassFld & other)
{
	type_ = other.type_->clone();
	listitem_ = other.listitem_->clone();

}

ClassFld &ClassFld::operator=(const ClassFld & other)
{
	ClassFld tmp(other);
	swap(tmp);
	return *this;
}

void ClassFld::swap(ClassFld & other)
{
	std::swap(type_, other.type_);
	std::swap(listitem_, other.listitem_);

}

ClassFld::~ClassFld()
{
	delete(type_);
	delete(listitem_);

}

void ClassFld::accept(Visitor *v)
{
	v->visitClassFld(this);
}

ClassFld *ClassFld::clone() const
{
	return new ClassFld(*this);
}



/********************   Blk    ********************/
Blk::Blk(ListStmt *p1)
{
	liststmt_ = p1;

}

Blk::Blk(const Blk & other)
{
	liststmt_ = other.liststmt_->clone();

}

Blk &Blk::operator=(const Blk & other)
{
	Blk tmp(other);
	swap(tmp);
	return *this;
}

void Blk::swap(Blk & other)
{
	std::swap(liststmt_, other.liststmt_);

}

Blk::~Blk()
{
	delete(liststmt_);

}

void Blk::accept(Visitor *v)
{
	v->visitBlk(this);
}

Blk *Blk::clone() const
{
	return new Blk(*this);
}



/********************   Empty    ********************/
Empty::Empty()
{

}

Empty::Empty(const Empty & other)
{

}

Empty &Empty::operator=(const Empty & other)
{
	Empty tmp(other);
	swap(tmp);
	return *this;
}

void Empty::swap(Empty & other)
{

}

Empty::~Empty()
{

}

void Empty::accept(Visitor *v)
{
	v->visitEmpty(this);
}

Empty *Empty::clone() const
{
	return new Empty(*this);
}



/********************   BStmt    ********************/
BStmt::BStmt(Block *p1)
{
	block_ = p1;

}

BStmt::BStmt(const BStmt & other)
{
	block_ = other.block_->clone();

}

BStmt &BStmt::operator=(const BStmt & other)
{
	BStmt tmp(other);
	swap(tmp);
	return *this;
}

void BStmt::swap(BStmt & other)
{
	std::swap(block_, other.block_);

}

BStmt::~BStmt()
{
	delete(block_);

}

void BStmt::accept(Visitor *v)
{
	v->visitBStmt(this);
}

BStmt *BStmt::clone() const
{
	return new BStmt(*this);
}



/********************   Decl    ********************/
Decl::Decl(Type *p1, ListItem *p2)
{
	type_ = p1;
	listitem_ = p2;

}

Decl::Decl(const Decl & other)
{
	type_ = other.type_->clone();
	listitem_ = other.listitem_->clone();

}

Decl &Decl::operator=(const Decl & other)
{
	Decl tmp(other);
	swap(tmp);
	return *this;
}

void Decl::swap(Decl & other)
{
	std::swap(type_, other.type_);
	std::swap(listitem_, other.listitem_);

}

Decl::~Decl()
{
	delete(type_);
	delete(listitem_);

}

void Decl::accept(Visitor *v)
{
	v->visitDecl(this);
}

Decl *Decl::clone() const
{
	return new Decl(*this);
}



/********************   Ass    ********************/
Ass::Ass(Expr *p1, Expr *p2)
{
	expr_1 = p1;
	expr_2 = p2;

}

Ass::Ass(const Ass & other)
{
	expr_1 = other.expr_1->clone();
	expr_2 = other.expr_2->clone();

}

Ass &Ass::operator=(const Ass & other)
{
	Ass tmp(other);
	swap(tmp);
	return *this;
}

void Ass::swap(Ass & other)
{
	std::swap(expr_1, other.expr_1);
	std::swap(expr_2, other.expr_2);

}

Ass::~Ass()
{
	delete(expr_1);
	delete(expr_2);

}

void Ass::accept(Visitor *v)
{
	v->visitAss(this);
}

Ass *Ass::clone() const
{
	return new Ass(*this);
}



/********************   TableAss    ********************/
TableAss::TableAss(PIdent *p1, Expr *p2, Expr *p3)
{
	pident_ = p1;
	expr_1 = p2;
	expr_2 = p3;

}

TableAss::TableAss(const TableAss & other)
{
	pident_ = other.pident_->clone();
	expr_1 = other.expr_1->clone();
	expr_2 = other.expr_2->clone();

}

TableAss &TableAss::operator=(const TableAss & other)
{
	TableAss tmp(other);
	swap(tmp);
	return *this;
}

void TableAss::swap(TableAss & other)
{
	std::swap(pident_, other.pident_);
	std::swap(expr_1, other.expr_1);
	std::swap(expr_2, other.expr_2);

}

TableAss::~TableAss()
{
	delete(pident_);
	delete(expr_1);
	delete(expr_2);

}

void TableAss::accept(Visitor *v)
{
	v->visitTableAss(this);
}

TableAss *TableAss::clone() const
{
	return new TableAss(*this);
}



/********************   TableIncr    ********************/
TableIncr::TableIncr(PIdent *p1, Expr *p2)
{
	pident_ = p1;
	expr_ = p2;

}

TableIncr::TableIncr(const TableIncr & other)
{
	pident_ = other.pident_->clone();
	expr_ = other.expr_->clone();

}

TableIncr &TableIncr::operator=(const TableIncr & other)
{
	TableIncr tmp(other);
	swap(tmp);
	return *this;
}

void TableIncr::swap(TableIncr & other)
{
	std::swap(pident_, other.pident_);
	std::swap(expr_, other.expr_);

}

TableIncr::~TableIncr()
{
	delete(pident_);
	delete(expr_);

}

void TableIncr::accept(Visitor *v)
{
	v->visitTableIncr(this);
}

TableIncr *TableIncr::clone() const
{
	return new TableIncr(*this);
}



/********************   TableDecr    ********************/
TableDecr::TableDecr(PIdent *p1, Expr *p2)
{
	pident_ = p1;
	expr_ = p2;

}

TableDecr::TableDecr(const TableDecr & other)
{
	pident_ = other.pident_->clone();
	expr_ = other.expr_->clone();

}

TableDecr &TableDecr::operator=(const TableDecr & other)
{
	TableDecr tmp(other);
	swap(tmp);
	return *this;
}

void TableDecr::swap(TableDecr & other)
{
	std::swap(pident_, other.pident_);
	std::swap(expr_, other.expr_);

}

TableDecr::~TableDecr()
{
	delete(pident_);
	delete(expr_);

}

void TableDecr::accept(Visitor *v)
{
	v->visitTableDecr(this);
}

TableDecr *TableDecr::clone() const
{
	return new TableDecr(*this);
}



/********************   Incr    ********************/
Incr::Incr(PIdent *p1)
{
	pident_ = p1;

}

Incr::Incr(const Incr & other)
{
	pident_ = other.pident_->clone();

}

Incr &Incr::operator=(const Incr & other)
{
	Incr tmp(other);
	swap(tmp);
	return *this;
}

void Incr::swap(Incr & other)
{
	std::swap(pident_, other.pident_);

}

Incr::~Incr()
{
	delete(pident_);

}

void Incr::accept(Visitor *v)
{
	v->visitIncr(this);
}

Incr *Incr::clone() const
{
	return new Incr(*this);
}



/********************   Decr    ********************/
Decr::Decr(PIdent *p1)
{
	pident_ = p1;

}

Decr::Decr(const Decr & other)
{
	pident_ = other.pident_->clone();

}

Decr &Decr::operator=(const Decr & other)
{
	Decr tmp(other);
	swap(tmp);
	return *this;
}

void Decr::swap(Decr & other)
{
	std::swap(pident_, other.pident_);

}

Decr::~Decr()
{
	delete(pident_);

}

void Decr::accept(Visitor *v)
{
	v->visitDecr(this);
}

Decr *Decr::clone() const
{
	return new Decr(*this);
}



/********************   Ret    ********************/
Ret::Ret(Expr *p1)
{
	expr_ = p1;

}

Ret::Ret(const Ret & other)
{
	expr_ = other.expr_->clone();

}

Ret &Ret::operator=(const Ret & other)
{
	Ret tmp(other);
	swap(tmp);
	return *this;
}

void Ret::swap(Ret & other)
{
	std::swap(expr_, other.expr_);

}

Ret::~Ret()
{
	delete(expr_);

}

void Ret::accept(Visitor *v)
{
	v->visitRet(this);
}

Ret *Ret::clone() const
{
	return new Ret(*this);
}



/********************   VRet    ********************/
VRet::VRet()
{

}

VRet::VRet(const VRet & other)
{

}

VRet &VRet::operator=(const VRet & other)
{
	VRet tmp(other);
	swap(tmp);
	return *this;
}

void VRet::swap(VRet & other)
{

}

VRet::~VRet()
{

}

void VRet::accept(Visitor *v)
{
	v->visitVRet(this);
}

VRet *VRet::clone() const
{
	return new VRet(*this);
}



/********************   Cond    ********************/
Cond::Cond(Expr *p1, Stmt *p2)
{
	expr_ = p1;
	stmt_ = p2;

}

Cond::Cond(const Cond & other)
{
	expr_ = other.expr_->clone();
	stmt_ = other.stmt_->clone();

}

Cond &Cond::operator=(const Cond & other)
{
	Cond tmp(other);
	swap(tmp);
	return *this;
}

void Cond::swap(Cond & other)
{
	std::swap(expr_, other.expr_);
	std::swap(stmt_, other.stmt_);

}

Cond::~Cond()
{
	delete(expr_);
	delete(stmt_);

}

void Cond::accept(Visitor *v)
{
	v->visitCond(this);
}

Cond *Cond::clone() const
{
	return new Cond(*this);
}



/********************   CondElse    ********************/
CondElse::CondElse(Expr *p1, Stmt *p2, Stmt *p3)
{
	expr_ = p1;
	stmt_1 = p2;
	stmt_2 = p3;

}

CondElse::CondElse(const CondElse & other)
{
	expr_ = other.expr_->clone();
	stmt_1 = other.stmt_1->clone();
	stmt_2 = other.stmt_2->clone();

}

CondElse &CondElse::operator=(const CondElse & other)
{
	CondElse tmp(other);
	swap(tmp);
	return *this;
}

void CondElse::swap(CondElse & other)
{
	std::swap(expr_, other.expr_);
	std::swap(stmt_1, other.stmt_1);
	std::swap(stmt_2, other.stmt_2);

}

CondElse::~CondElse()
{
	delete(expr_);
	delete(stmt_1);
	delete(stmt_2);

}

void CondElse::accept(Visitor *v)
{
	v->visitCondElse(this);
}

CondElse *CondElse::clone() const
{
	return new CondElse(*this);
}



/********************   While    ********************/
While::While(Expr *p1, Stmt *p2)
{
	expr_ = p1;
	stmt_ = p2;

}

While::While(const While & other)
{
	expr_ = other.expr_->clone();
	stmt_ = other.stmt_->clone();

}

While &While::operator=(const While & other)
{
	While tmp(other);
	swap(tmp);
	return *this;
}

void While::swap(While & other)
{
	std::swap(expr_, other.expr_);
	std::swap(stmt_, other.stmt_);

}

While::~While()
{
	delete(expr_);
	delete(stmt_);

}

void While::accept(Visitor *v)
{
	v->visitWhile(this);
}

While *While::clone() const
{
	return new While(*this);
}



/********************   SExp    ********************/
SExp::SExp(Expr *p1)
{
	expr_ = p1;

}

SExp::SExp(const SExp & other)
{
	expr_ = other.expr_->clone();

}

SExp &SExp::operator=(const SExp & other)
{
	SExp tmp(other);
	swap(tmp);
	return *this;
}

void SExp::swap(SExp & other)
{
	std::swap(expr_, other.expr_);

}

SExp::~SExp()
{
	delete(expr_);

}

void SExp::accept(Visitor *v)
{
	v->visitSExp(this);
}

SExp *SExp::clone() const
{
	return new SExp(*this);
}



/********************   ForEach    ********************/
ForEach::ForEach(Type *p1, PIdent *p2, Expr *p3, Stmt *p4)
{
	type_ = p1;
	pident_ = p2;
	expr_ = p3;
	stmt_ = p4;

}

ForEach::ForEach(const ForEach & other)
{
	type_ = other.type_->clone();
	pident_ = other.pident_->clone();
	expr_ = other.expr_->clone();
	stmt_ = other.stmt_->clone();

}

ForEach &ForEach::operator=(const ForEach & other)
{
	ForEach tmp(other);
	swap(tmp);
	return *this;
}

void ForEach::swap(ForEach & other)
{
	std::swap(type_, other.type_);
	std::swap(pident_, other.pident_);
	std::swap(expr_, other.expr_);
	std::swap(stmt_, other.stmt_);

}

ForEach::~ForEach()
{
	delete(type_);
	delete(pident_);
	delete(expr_);
	delete(stmt_);

}

void ForEach::accept(Visitor *v)
{
	v->visitForEach(this);
}

ForEach *ForEach::clone() const
{
	return new ForEach(*this);
}



/********************   Init    ********************/
Item::Item(PIdent *p1, Expr *p2)
{
	pident_ = p1;
	expr_ = p2;

}

Item::Item(const Item & other)
{
	pident_ = other.pident_->clone();
	expr_ = other.expr_->clone();

}

Item &Item::operator=(const Item & other)
{
	Item tmp(other);
	swap(tmp);
	return *this;
}

void Item::swap(Item & other)
{
	std::swap(pident_, other.pident_);
	std::swap(expr_, other.expr_);

}

Item::~Item()
{
	delete(pident_);
	delete(expr_);

}

void Item::accept(Visitor *v)
{
	v->visitItem(this);
}

Item *Item::clone() const
{
	return new Item(*this);
}



/********************   Int    ********************/
Int::Int()
{

}

Int::Int(const Int & other)
{

}

Int &Int::operator=(const Int & other)
{
	Int tmp(other);
	swap(tmp);
	return *this;
}

void Int::swap(Int & other)
{

}

Int::~Int()
{

}

void Int::accept(Visitor *v)
{
	v->visitInt(this);
}

Int *Int::clone() const
{
	return new Int(*this);
}



/********************   Str    ********************/
Str::Str()
{

}

Str::Str(const Str & other)
{

}

Str &Str::operator=(const Str & other)
{
	Str tmp(other);
	swap(tmp);
	return *this;
}

void Str::swap(Str & other)
{

}

Str::~Str()
{

}

void Str::accept(Visitor *v)
{
	v->visitStr(this);
}

Str *Str::clone() const
{
	return new Str(*this);
}



/********************   Bool    ********************/
Bool::Bool()
{

}

Bool::Bool(const Bool & other)
{

}

Bool &Bool::operator=(const Bool & other)
{
	Bool tmp(other);
	swap(tmp);
	return *this;
}

void Bool::swap(Bool & other)
{

}

Bool::~Bool()
{

}

void Bool::accept(Visitor *v)
{
	v->visitBool(this);
}

Bool *Bool::clone() const
{
	return new Bool(*this);
}



/********************   Void    ********************/
Void::Void()
{

}

Void::Void(const Void & other)
{

}

Void &Void::operator=(const Void & other)
{
	Void tmp(other);
	swap(tmp);
	return *this;
}

void Void::swap(Void & other)
{

}

Void::~Void()
{

}

void Void::accept(Visitor *v)
{
	v->visitVoid(this);
}

Void *Void::clone() const
{
	return new Void(*this);
}



/********************   Array    ********************/
Array::Array(Type *p1)
{
	type_ = p1;

}

Array::Array(const Array & other)
{
	type_ = other.type_->clone();

}

Array &Array::operator=(const Array & other)
{
	Array tmp(other);
	swap(tmp);
	return *this;
}

void Array::swap(Array & other)
{
	std::swap(type_, other.type_);

}

Array::~Array()
{
	delete(type_);

}

void Array::accept(Visitor *v)
{
	v->visitArray(this);
}

Array *Array::clone() const
{
	return new Array(*this);
}



/********************   ClassT    ********************/
ClassT::ClassT(PIdent *p1)
{
	pident_ = p1;

}

ClassT::ClassT(const ClassT & other)
{
	pident_ = other.pident_->clone();

}

ClassT &ClassT::operator=(const ClassT & other)
{
	ClassT tmp(other);
	swap(tmp);
	return *this;
}

void ClassT::swap(ClassT & other)
{
	std::swap(pident_, other.pident_);

}

ClassT::~ClassT()
{
	delete(pident_);

}

void ClassT::accept(Visitor *v)
{
	v->visitClassT(this);
}

ClassT *ClassT::clone() const
{
	return new ClassT(*this);
}



/********************   Fun    ********************/
Fun::Fun(Type *p1, ListType *p2)
{
	type_ = p1;
	listtype_ = p2;

}

Fun::Fun(const Fun & other)
{
	type_ = other.type_->clone();
	listtype_ = other.listtype_->clone();

}

Fun &Fun::operator=(const Fun & other)
{
	Fun tmp(other);
	swap(tmp);
	return *this;
}

void Fun::swap(Fun & other)
{
	std::swap(type_, other.type_);
	std::swap(listtype_, other.listtype_);

}

Fun::~Fun()
{
	delete(type_);
	delete(listtype_);

}

void Fun::accept(Visitor *v)
{
	v->visitFun(this);
}

Fun *Fun::clone() const
{
	return new Fun(*this);
}



/********************   EVar    ********************/
EVar::EVar(PIdent *p1)
{
	pident_ = p1;

}

EVar::EVar(const EVar & other)
{
	pident_ = other.pident_->clone();

}

EVar &EVar::operator=(const EVar & other)
{
	EVar tmp(other);
	swap(tmp);
	return *this;
}

void EVar::swap(EVar & other)
{
	std::swap(pident_, other.pident_);

}

EVar::~EVar()
{
	delete(pident_);

}

void EVar::accept(Visitor *v)
{
	v->visitEVar(this);
}

EVar *EVar::clone() const
{
	return new EVar(*this);
}



/********************   ELitInt    ********************/
ELitInt::ELitInt(Integer p1)
{
	integer_ = p1;

}

ELitInt::ELitInt(const ELitInt & other)
{
	integer_ = other.integer_;

}

ELitInt &ELitInt::operator=(const ELitInt & other)
{
	ELitInt tmp(other);
	swap(tmp);
	return *this;
}

void ELitInt::swap(ELitInt & other)
{
	std::swap(integer_, other.integer_);

}

ELitInt::~ELitInt()
{

}

void ELitInt::accept(Visitor *v)
{
	v->visitELitInt(this);
}

ELitInt *ELitInt::clone() const
{
	return new ELitInt(*this);
}



/********************   ELitTrue    ********************/
ELitTrue::ELitTrue()
{

}

ELitTrue::ELitTrue(const ELitTrue & other)
{

}

ELitTrue &ELitTrue::operator=(const ELitTrue & other)
{
	ELitTrue tmp(other);
	swap(tmp);
	return *this;
}

void ELitTrue::swap(ELitTrue & other)
{

}

ELitTrue::~ELitTrue()
{

}

void ELitTrue::accept(Visitor *v)
{
	v->visitELitTrue(this);
}

ELitTrue *ELitTrue::clone() const
{
	return new ELitTrue(*this);
}



/********************   ELitFalse    ********************/
ELitFalse::ELitFalse()
{

}

ELitFalse::ELitFalse(const ELitFalse & other)
{

}

ELitFalse &ELitFalse::operator=(const ELitFalse & other)
{
	ELitFalse tmp(other);
	swap(tmp);
	return *this;
}

void ELitFalse::swap(ELitFalse & other)
{

}

ELitFalse::~ELitFalse()
{

}

void ELitFalse::accept(Visitor *v)
{
	v->visitELitFalse(this);
}

ELitFalse *ELitFalse::clone() const
{
	return new ELitFalse(*this);
}



/********************   EApp    ********************/
EApp::EApp(PIdent *p1, ListExpr *p2)
{
	pident_ = p1;
	listexpr_ = p2;

}

EApp::EApp(const EApp & other)
{
	pident_ = other.pident_->clone();
	listexpr_ = other.listexpr_->clone();

}

EApp &EApp::operator=(const EApp & other)
{
	EApp tmp(other);
	swap(tmp);
	return *this;
}

void EApp::swap(EApp & other)
{
	std::swap(pident_, other.pident_);
	std::swap(listexpr_, other.listexpr_);

}

EApp::~EApp()
{
	delete(pident_);
	delete(listexpr_);

}

void EApp::accept(Visitor *v)
{
	v->visitEApp(this);
}

EApp *EApp::clone() const
{
	return new EApp(*this);
}



/********************   EString    ********************/
EString::EString(String p1)
{
	string_ = p1;

}

EString::EString(const EString & other)
{
	string_ = other.string_;

}

EString &EString::operator=(const EString & other)
{
	EString tmp(other);
	swap(tmp);
	return *this;
}

void EString::swap(EString & other)
{
	std::swap(string_, other.string_);

}

EString::~EString()
{

}

void EString::accept(Visitor *v)
{
	v->visitEString(this);
}

EString *EString::clone() const
{
	return new EString(*this);
}



/********************   ENewArray    ********************/
ENewArray::ENewArray(Type *p1, Expr *p2)
{
	type_ = p1;
	expr_ = p2;

}

ENewArray::ENewArray(const ENewArray & other)
{
	type_ = other.type_->clone();
	expr_ = other.expr_->clone();

}

ENewArray &ENewArray::operator=(const ENewArray & other)
{
	ENewArray tmp(other);
	swap(tmp);
	return *this;
}

void ENewArray::swap(ENewArray & other)
{
	std::swap(type_, other.type_);
	std::swap(expr_, other.expr_);

}

ENewArray::~ENewArray()
{
	delete(type_);
	delete(expr_);

}

void ENewArray::accept(Visitor *v)
{
	v->visitENewArray(this);
}

ENewArray *ENewArray::clone() const
{
	return new ENewArray(*this);
}



/********************   ENewClass    ********************/
ENewClass::ENewClass(PIdent *p1)
{
	pident_ = p1;

}

ENewClass::ENewClass(const ENewClass & other)
{
	pident_ = other.pident_->clone();

}

ENewClass &ENewClass::operator=(const ENewClass & other)
{
	ENewClass tmp(other);
	swap(tmp);
	return *this;
}

void ENewClass::swap(ENewClass & other)
{
	std::swap(pident_, other.pident_);

}

ENewClass::~ENewClass()
{
	delete(pident_);

}

void ENewClass::accept(Visitor *v)
{
	v->visitENewClass(this);
}

ENewClass *ENewClass::clone() const
{
	return new ENewClass(*this);
}



/********************   EClsMmbr    ********************/
EClsMmbr::EClsMmbr(Expr *p1, PIdent *p2)
{
	expr_ = p1;
	pident_ = p2;

}

EClsMmbr::EClsMmbr(const EClsMmbr & other)
{
	expr_ = other.expr_->clone();
	pident_ = other.pident_->clone();

}

EClsMmbr &EClsMmbr::operator=(const EClsMmbr & other)
{
	EClsMmbr tmp(other);
	swap(tmp);
	return *this;
}

void EClsMmbr::swap(EClsMmbr & other)
{
	std::swap(expr_, other.expr_);
	std::swap(pident_, other.pident_);

}

EClsMmbr::~EClsMmbr()
{
	delete(expr_);
	delete(pident_);

}

void EClsMmbr::accept(Visitor *v)
{
	v->visitEClsMmbr(this);
}

EClsMmbr *EClsMmbr::clone() const
{
	return new EClsMmbr(*this);
}



/********************   EClsMthd    ********************/
EClsMthd::EClsMthd(Expr *p1, PIdent *p2, ListExpr *p3)
{
	expr_ = p1;
	pident_ = p2;
	listexpr_ = p3;

}

EClsMthd::EClsMthd(const EClsMthd & other)
{
	expr_ = other.expr_->clone();
	pident_ = other.pident_->clone();
	listexpr_ = other.listexpr_->clone();

}

EClsMthd &EClsMthd::operator=(const EClsMthd & other)
{
	EClsMthd tmp(other);
	swap(tmp);
	return *this;
}

void EClsMthd::swap(EClsMthd & other)
{
	std::swap(expr_, other.expr_);
	std::swap(pident_, other.pident_);
	std::swap(listexpr_, other.listexpr_);

}

EClsMthd::~EClsMthd()
{
	delete(expr_);
	delete(pident_);
	delete(listexpr_);

}

void EClsMthd::accept(Visitor *v)
{
	v->visitEClsMthd(this);
}

EClsMthd *EClsMthd::clone() const
{
	return new EClsMthd(*this);
}



/********************   Null    ********************/
Null::Null()
{

}

Null::Null(const Null & other)
{

}

Null &Null::operator=(const Null & other)
{
	Null tmp(other);
	swap(tmp);
	return *this;
}

void Null::swap(Null & other)
{

}

Null::~Null()
{

}

void Null::accept(Visitor *v)
{
	v->visitNull(this);
}

Null *Null::clone() const
{
	return new Null(*this);
}



/********************   EIndexAcc    ********************/
EIndexAcc::EIndexAcc(PIdent *p1, Expr *p2)
{
	pident_ = p1;
	expr_ = p2;

}

EIndexAcc::EIndexAcc(const EIndexAcc & other)
{
	pident_ = other.pident_->clone();
	expr_ = other.expr_->clone();

}

EIndexAcc &EIndexAcc::operator=(const EIndexAcc & other)
{
	EIndexAcc tmp(other);
	swap(tmp);
	return *this;
}

void EIndexAcc::swap(EIndexAcc & other)
{
	std::swap(pident_, other.pident_);
	std::swap(expr_, other.expr_);

}

EIndexAcc::~EIndexAcc()
{
	delete(pident_);
	delete(expr_);

}

void EIndexAcc::accept(Visitor *v)
{
	v->visitEIndexAcc(this);
}

EIndexAcc *EIndexAcc::clone() const
{
	return new EIndexAcc(*this);
}



/********************   ECast    ********************/
ECast::ECast(PIdent *p1, Expr *p2)
{
	pident_ = p1;
	expr_ = p2;

}

ECast::ECast(const ECast & other)
{
	pident_ = other.pident_->clone();
	expr_ = other.expr_->clone();

}

ECast &ECast::operator=(const ECast & other)
{
	ECast tmp(other);
	swap(tmp);
	return *this;
}

void ECast::swap(ECast & other)
{
	std::swap(pident_, other.pident_);
	std::swap(expr_, other.expr_);

}

ECast::~ECast()
{
	delete(pident_);
	delete(expr_);

}

void ECast::accept(Visitor *v)
{
	v->visitECast(this);
}

ECast *ECast::clone() const
{
	return new ECast(*this);
}



/********************   Neg    ********************/
Neg::Neg(Expr *p1)
{
	expr_ = p1;

}

Neg::Neg(const Neg & other)
{
	expr_ = other.expr_->clone();

}

Neg &Neg::operator=(const Neg & other)
{
	Neg tmp(other);
	swap(tmp);
	return *this;
}

void Neg::swap(Neg & other)
{
	std::swap(expr_, other.expr_);

}

Neg::~Neg()
{
	delete(expr_);

}

void Neg::accept(Visitor *v)
{
	v->visitNeg(this);
}

Neg *Neg::clone() const
{
	return new Neg(*this);
}



/********************   Not    ********************/
Not::Not(Expr *p1)
{
	expr_ = p1;

}

Not::Not(const Not & other)
{
	expr_ = other.expr_->clone();

}

Not &Not::operator=(const Not & other)
{
	Not tmp(other);
	swap(tmp);
	return *this;
}

void Not::swap(Not & other)
{
	std::swap(expr_, other.expr_);

}

Not::~Not()
{
	delete(expr_);

}

void Not::accept(Visitor *v)
{
	v->visitNot(this);
}

Not *Not::clone() const
{
	return new Not(*this);
}



/********************   EMul    ********************/
EMul::EMul(Expr *p1, MulOp *p2, Expr *p3)
{
	expr_1 = p1;
	mulop_ = p2;
	expr_2 = p3;

}

EMul::EMul(const EMul & other)
{
	expr_1 = other.expr_1->clone();
	mulop_ = other.mulop_->clone();
	expr_2 = other.expr_2->clone();

}

EMul &EMul::operator=(const EMul & other)
{
	EMul tmp(other);
	swap(tmp);
	return *this;
}

void EMul::swap(EMul & other)
{
	std::swap(expr_1, other.expr_1);
	std::swap(mulop_, other.mulop_);
	std::swap(expr_2, other.expr_2);

}

EMul::~EMul()
{
	delete(expr_1);
	delete(mulop_);
	delete(expr_2);

}

void EMul::accept(Visitor *v)
{
	v->visitEMul(this);
}

EMul *EMul::clone() const
{
	return new EMul(*this);
}



/********************   EAdd    ********************/
EAdd::EAdd(Expr *p1, AddOp *p2, Expr *p3)
{
	expr_1 = p1;
	addop_ = p2;
	expr_2 = p3;

}

EAdd::EAdd(const EAdd & other)
{
	expr_1 = other.expr_1->clone();
	addop_ = other.addop_->clone();
	expr_2 = other.expr_2->clone();

}

EAdd &EAdd::operator=(const EAdd & other)
{
	EAdd tmp(other);
	swap(tmp);
	return *this;
}

void EAdd::swap(EAdd & other)
{
	std::swap(expr_1, other.expr_1);
	std::swap(addop_, other.addop_);
	std::swap(expr_2, other.expr_2);

}

EAdd::~EAdd()
{
	delete(expr_1);
	delete(addop_);
	delete(expr_2);

}

void EAdd::accept(Visitor *v)
{
	v->visitEAdd(this);
}

EAdd *EAdd::clone() const
{
	return new EAdd(*this);
}



/********************   ERel    ********************/
ERel::ERel(Expr *p1, RelOp *p2, Expr *p3)
{
	expr_1 = p1;
	relop_ = p2;
	expr_2 = p3;

}

ERel::ERel(const ERel & other)
{
	expr_1 = other.expr_1->clone();
	relop_ = other.relop_->clone();
	expr_2 = other.expr_2->clone();

}

ERel &ERel::operator=(const ERel & other)
{
	ERel tmp(other);
	swap(tmp);
	return *this;
}

void ERel::swap(ERel & other)
{
	std::swap(expr_1, other.expr_1);
	std::swap(relop_, other.relop_);
	std::swap(expr_2, other.expr_2);

}

ERel::~ERel()
{
	delete(expr_1);
	delete(relop_);
	delete(expr_2);

}

void ERel::accept(Visitor *v)
{
	v->visitERel(this);
}

ERel *ERel::clone() const
{
	return new ERel(*this);
}



/********************   EAnd    ********************/
EAnd::EAnd(Expr *p1, Expr *p2)
{
	expr_1 = p1;
	expr_2 = p2;

}

EAnd::EAnd(const EAnd & other)
{
	expr_1 = other.expr_1->clone();
	expr_2 = other.expr_2->clone();

}

EAnd &EAnd::operator=(const EAnd & other)
{
	EAnd tmp(other);
	swap(tmp);
	return *this;
}

void EAnd::swap(EAnd & other)
{
	std::swap(expr_1, other.expr_1);
	std::swap(expr_2, other.expr_2);

}

EAnd::~EAnd()
{
	delete(expr_1);
	delete(expr_2);

}

void EAnd::accept(Visitor *v)
{
	v->visitEAnd(this);
}

EAnd *EAnd::clone() const
{
	return new EAnd(*this);
}



/********************   EOr    ********************/
EOr::EOr(Expr *p1, Expr *p2)
{
	expr_1 = p1;
	expr_2 = p2;

}

EOr::EOr(const EOr & other)
{
	expr_1 = other.expr_1->clone();
	expr_2 = other.expr_2->clone();

}

EOr &EOr::operator=(const EOr & other)
{
	EOr tmp(other);
	swap(tmp);
	return *this;
}

void EOr::swap(EOr & other)
{
	std::swap(expr_1, other.expr_1);
	std::swap(expr_2, other.expr_2);

}

EOr::~EOr()
{
	delete(expr_1);
	delete(expr_2);

}

void EOr::accept(Visitor *v)
{
	v->visitEOr(this);
}

EOr *EOr::clone() const
{
	return new EOr(*this);
}



/********************   Plus    ********************/
Plus::Plus()
{

}

Plus::Plus(const Plus & other)
{

}

Plus &Plus::operator=(const Plus & other)
{
	Plus tmp(other);
	swap(tmp);
	return *this;
}

void Plus::swap(Plus & other)
{

}

Plus::~Plus()
{

}

void Plus::accept(Visitor *v)
{
	v->visitPlus(this);
}

Plus *Plus::clone() const
{
	return new Plus(*this);
}



/********************   Minus    ********************/
Minus::Minus()
{

}

Minus::Minus(const Minus & other)
{

}

Minus &Minus::operator=(const Minus & other)
{
	Minus tmp(other);
	swap(tmp);
	return *this;
}

void Minus::swap(Minus & other)
{

}

Minus::~Minus()
{

}

void Minus::accept(Visitor *v)
{
	v->visitMinus(this);
}

Minus *Minus::clone() const
{
	return new Minus(*this);
}



/********************   Times    ********************/
Times::Times()
{

}

Times::Times(const Times & other)
{

}

Times &Times::operator=(const Times & other)
{
	Times tmp(other);
	swap(tmp);
	return *this;
}

void Times::swap(Times & other)
{

}

Times::~Times()
{

}

void Times::accept(Visitor *v)
{
	v->visitTimes(this);
}

Times *Times::clone() const
{
	return new Times(*this);
}



/********************   Div    ********************/
Div::Div()
{

}

Div::Div(const Div & other)
{

}

Div &Div::operator=(const Div & other)
{
	Div tmp(other);
	swap(tmp);
	return *this;
}

void Div::swap(Div & other)
{

}

Div::~Div()
{

}

void Div::accept(Visitor *v)
{
	v->visitDiv(this);
}

Div *Div::clone() const
{
	return new Div(*this);
}



/********************   Mod    ********************/
Mod::Mod()
{

}

Mod::Mod(const Mod & other)
{

}

Mod &Mod::operator=(const Mod & other)
{
	Mod tmp(other);
	swap(tmp);
	return *this;
}

void Mod::swap(Mod & other)
{

}

Mod::~Mod()
{

}

void Mod::accept(Visitor *v)
{
	v->visitMod(this);
}

Mod *Mod::clone() const
{
	return new Mod(*this);
}



/********************   LTH    ********************/
LTH::LTH()
{

}

LTH::LTH(const LTH & other)
{

}

LTH &LTH::operator=(const LTH & other)
{
	LTH tmp(other);
	swap(tmp);
	return *this;
}

void LTH::swap(LTH & other)
{

}

LTH::~LTH()
{

}

void LTH::accept(Visitor *v)
{
	v->visitLTH(this);
}

LTH *LTH::clone() const
{
	return new LTH(*this);
}



/********************   LE    ********************/
LE::LE()
{

}

LE::LE(const LE & other)
{

}

LE &LE::operator=(const LE & other)
{
	LE tmp(other);
	swap(tmp);
	return *this;
}

void LE::swap(LE & other)
{

}

LE::~LE()
{

}

void LE::accept(Visitor *v)
{
	v->visitLE(this);
}

LE *LE::clone() const
{
	return new LE(*this);
}



/********************   GTH    ********************/
GTH::GTH()
{

}

GTH::GTH(const GTH & other)
{

}

GTH &GTH::operator=(const GTH & other)
{
	GTH tmp(other);
	swap(tmp);
	return *this;
}

void GTH::swap(GTH & other)
{

}

GTH::~GTH()
{

}

void GTH::accept(Visitor *v)
{
	v->visitGTH(this);
}

GTH *GTH::clone() const
{
	return new GTH(*this);
}



/********************   GE    ********************/
GE::GE()
{

}

GE::GE(const GE & other)
{

}

GE &GE::operator=(const GE & other)
{
	GE tmp(other);
	swap(tmp);
	return *this;
}

void GE::swap(GE & other)
{

}

GE::~GE()
{

}

void GE::accept(Visitor *v)
{
	v->visitGE(this);
}

GE *GE::clone() const
{
	return new GE(*this);
}



/********************   EQU    ********************/
EQU::EQU()
{

}

EQU::EQU(const EQU & other)
{

}

EQU &EQU::operator=(const EQU & other)
{
	EQU tmp(other);
	swap(tmp);
	return *this;
}

void EQU::swap(EQU & other)
{

}

EQU::~EQU()
{

}

void EQU::accept(Visitor *v)
{
	v->visitEQU(this);
}

EQU *EQU::clone() const
{
	return new EQU(*this);
}



/********************   NE    ********************/
NE::NE()
{

}

NE::NE(const NE & other)
{

}

NE &NE::operator=(const NE & other)
{
	NE tmp(other);
	swap(tmp);
	return *this;
}

void NE::swap(NE & other)
{

}

NE::~NE()
{

}

void NE::accept(Visitor *v)
{
	v->visitNE(this);
}

NE *NE::clone() const
{
	return new NE(*this);
}




/********************   ListTopDef    ********************/

void ListTopDef::accept(Visitor *v)
{
	v->visitListTopDef(this);
}


ListTopDef *ListTopDef::clone() const
{
	return new ListTopDef(*this);
}


/********************   ListArg    ********************/

void ListArg::accept(Visitor *v)
{
	v->visitListArg(this);
}


ListArg *ListArg::clone() const
{
	return new ListArg(*this);
}


/********************   ListClassBlockDef    ********************/

void ListClassBlockDef::accept(Visitor *v)
{
	v->visitListClassBlockDef(this);
}


ListClassBlockDef *ListClassBlockDef::clone() const
{
	return new ListClassBlockDef(*this);
}


/********************   ListStmt    ********************/

void ListStmt::accept(Visitor *v)
{
	v->visitListStmt(this);
}


ListStmt *ListStmt::clone() const
{
	return new ListStmt(*this);
}


/********************   ListItem    ********************/

void ListItem::accept(Visitor *v)
{
	v->visitListItem(this);
}


ListItem *ListItem::clone() const
{
	return new ListItem(*this);
}


/********************   ListType    ********************/

void ListType::accept(Visitor *v)
{
	v->visitListType(this);
}


ListType *ListType::clone() const
{
	return new ListType(*this);
}


/********************   ListExpr    ********************/

void ListExpr::accept(Visitor *v)
{
	v->visitListExpr(this);
}


ListExpr *ListExpr::clone() const
{
	return new ListExpr(*this);
}



std::string Fun::printName() const{
	std::string ret = type_->printName() + "(";
	bool fst = true;
	for (auto i : *listtype_) {
		if (fst) fst = false;
		else ret += ", ";
		ret += i->printName();
	}
	return ret + ")";
}

bool Fun::isEqual(Type const *other) const {
		if (const Fun* casted = dynamic_cast<const Fun*>(other)) {
			if (*type_ != *casted->type_ || listtype_->size() != casted->listtype_->size()) return false;

		}
		return false;
	}